/* This file was automatically generated.  Do not edit! */
typedef struct hub hub;
struct hub {
  gboolean adc; // TRUE = ADC, FALSE = NMDC protocol.
  int state;    // ADC_S_* (ADC only)
  struct ui_tab *tab; // to get name (for config) and for logging & setting of title
  struct net *net;
  // nick as used in this connection, NULL when not sent yet
  char *nick_hub; // in hub encoding (NMDC only)
  char *nick;     // UTF-8
  int sid;        // session ID (ADC only)
  // TRUE is the above nick has also been validated (and we're properly logged in)
  gboolean nick_valid;
  gboolean isreg; // whether we used a password to login
  gboolean isop;  // whether we're an OP or not
  char *hubname;  // UTF-8, or NULL when unknown
  char *hubname_hub; // in hub encoding (NMDC only)
  // user list, key = username (in hub encoding for NMDC), value = struct hub_user *
  GHashTable *users;
  GHashTable *sessions; // user list, with sid as index (ADC only)
  int sharecount;
  guint64 sharesize;
  // what we and the hub support
  gboolean supports_nogetinfo;
  // MyINFO send timer (event loop source id)
  guint nfo_timer;
  // reconnect timer (30 sec.)
  guint reconnect_timer;
  // ADC login info
  char *gpa_salt;
  int gpa_salt_len;
  // last info we sent to the hub
  char *nfo_desc, *nfo_conn, *nfo_mail;
  unsigned char nfo_slots, nfo_h_norm, nfo_h_reg, nfo_h_op;
  guint64 nfo_share;
  guint32 nfo_ip4;
  unsigned short nfo_port;
  // whether we've fetched the complete user list (and their $MyINFO's)
  gboolean received_first; // true if one precondition for joincomplete is satisfied.
  gboolean joincomplete;
  guint64 id; // "hubid" number
};
void hub_free(struct hub *hub);
struct hub *hub_create(struct ui_tab *tab);
void hub_connect(struct hub *hub);
void hub_disconnect(struct hub *hub,gboolean recon);
typedef struct hub_user hub_user;
void hub_msg(struct hub *hub,struct hub_user *user,const char *str,gboolean me);
void hub_say(struct hub *hub,const char *str,gboolean me);
void hub_search(struct hub *hub,struct search_q *q);
void hub_opencc(struct hub *hub,struct hub_user *u);
void hub_kick(struct hub *hub,struct hub_user *u);
void hub_password(struct hub *hub,char *pass);
void hub_send_nfo(struct hub *hub);
void hub_global_nfochange();
char *hub_user_tag(struct hub_user *u);
void hub_user_suggest(struct hub *hub,char *str,char **sug);
struct hub_user *hub_user_get(struct hub *hub,const char *name);
extern GHashTable *hub_uids;
#define hub_init_global() hub_uids = g_hash_table_new(g_int64_hash, g_int64_equal)
struct hub_user {
  gboolean hasinfo : 1;
  gboolean isop : 1;
  gboolean isjoined : 1; // managed by ui_hub_userchange()
  gboolean active : 1;
  gboolean hasudp4 : 1;
  unsigned char h_norm;
  unsigned char h_reg;
  unsigned char h_op;
  unsigned char slots;
  unsigned short udp4;
  unsigned int as;       // auto-open slot if upload is below n bytes/s
  guint32 ip4;
  int sid;        // for ADC
  struct hub *hub;
  char *name;     // UTF-8
  char *name_hub; // hub-encoded (NMDC)
  char *desc;
  char *conn;
  char *mail;
  char *client;
  char cid[8];   // for ADC - only the first 8 bytes of the CID, for simple verification purposes
  guint64 uid;
  guint64 sharesize;
  GSequenceIter *iter; // used by ui_userlist_*
};
#define INTERFACE 0
