/* This file was automatically generated.  Do not edit! */
void net_init_global();
void net_udp_sendf(const char *dest,const char *fmt,...);
void net_udp_send(const char *dest,const char *msg);
void net_udp_send_raw(const char *dest,const char *msg,int len);
typedef struct net net;
void net_recvfile(struct net *n,guint64 length,void(*cb)(struct net *,int,char *,guint64));
void net_sendfile(struct net *n,const char *path,guint64 offset,guint64 length);
void net_sendf(struct net *n,const char *fmt,...);
void net_send_raw(struct net *n,const char *msg,int len);
struct net *net_create(char term,void *han,gboolean keepalive,void(*rfunc)(struct net *,char *),void(*errfunc)(struct net *,int,GError *));
void net_setsock(struct net *n,GSocket *sock);
void net_connect(struct net *n,const char *addr,unsigned short defport,void(*cb)(struct net *));
void net_send(struct net *n,const char *msg);
#define net_cancel(n) do {\
    if((n)->in_src) {\
      g_source_remove((n)->in_src);\
      (n)->in_src = 0;\
    }\
    if((n)->out_src) {\
      g_source_remove((n)->out_src);\
      (n)->out_src = 0;\
    }\
    g_cancellable_cancel((n)->cancel);\
    g_object_unref((n)->cancel);\
    (n)->cancel = g_cancellable_new();\
    (n)->connecting = FALSE;\
  } while(0)
char *net_remoteaddr(struct net *n);
#define net_disconnect(n) do {\
    net_cancel(n);\
    if((n)->conn) {\
      g_debug("%s- Disconnected.", net_remoteaddr(n));\
      g_object_unref((n)->conn);\
      (n)->conn = NULL;\
      g_string_truncate((n)->in, 0);\
      g_string_truncate((n)->out, 0);\
      (n)->recv_left = 0;\
      (n)->recv_cb = NULL;\
      if((n)->setsock) {\
        g_object_unref((n)->sock);\
        (n)->setsock = FALSE;\
      }\
      if((n)->file_left) {\
        close((n)->file_fd);\
        (n)->file_left = 0;\
      }\
      ratecalc_unregister((n)->rate_in);\
      ratecalc_unregister((n)->rate_out);\
      time(&(n)->timeout_last);\
    }\
  } while(0)
struct net {
  GSocketConnection *conn;
  GSocket *sock;
  gboolean connecting;
  // input/output buffers
  GString *in, *out;
  GCancellable *cancel; // used to cancel a connect operation
  guint in_src, out_src;
  // sending a file
  int file_fd;
  gint64 file_left;
  guint64 file_offset;
  // receiving raw data (a file, usually)
  guint64 recv_left;
  void (*recv_cb)(struct net *, int, char *, guint64); // don't confuse the name with cb_rcv...
  // in/out rates
  struct ratecalc *rate_in;
  struct ratecalc *rate_out;
  // receive callback
  void (*cb_rcv)(struct net *, char *);
  // on-connect callback
  void (*cb_con)(struct net *);
  // Error callback. In the case of an error while connecting, cb_con will not
  // be called. Second argument is NETERR_* action. The GError does not have to
  // be freed. Will not be called in the case of G_IO_ERROR_CANCELLED. All
  // errors are fatal, and net_disconnect() should be called in the callback.
  void (*cb_err)(struct net *, int, GError *);
  // special hook that is called when data has arrived but before it is processed.
  void (*cb_datain)(struct net *, char *data);
  // message termination character
  char eom[2];
  // Whether this connection should be kept alive or not. When true, keepalive
  // packets will be sent. Otherwise, an error will be generated if there has
  // been no read activity within the last 30 seconds (or so).
  gboolean keepalive;
  // Whether _connect() or _setsock() was used.
  gboolean setsock;
  // Don't use _set_timeout() on the socket, since that will throw a timeout
  // even when we're actively writing to the socket. So we use our own timeout
  // detection using a 5-second timer and a timestamp of the last action.
  guint timeout_src;
  time_t timeout_last;
  // some pointer for use by the user
  void *handle;
  // reference counter
  int ref;
};
#define net_unref(n) do {\
    if(g_atomic_int_dec_and_test(&((n)->ref))) {\
      net_disconnect(n);\
      if((n)->file_left)\
        close((n)->file_fd);\
      if((n)->timeout_src)\
        g_source_remove((n)->timeout_src);\
      g_object_unref((n)->cancel);\
      g_string_free((n)->out, TRUE);\
      g_string_free((n)->in, TRUE);\
      g_slice_free(struct ratecalc, (n)->rate_in);\
      g_slice_free(struct ratecalc, (n)->rate_out);\
      g_slice_free(struct net, n);\
    }\
  } while(0)
#define net_ref(n) g_atomic_int_inc(&((n)->ref))
#define NETERR_SEND 2
#define NETERR_RECV 1
#define NETERR_CONN 0
#define INTERFACE 0
extern struct ratecalc net_in,net_out;
