/* This file was automatically generated.  Do not edit! */
typedef struct search_q search_q;
char *search_command(struct search_q *q,gboolean onhub);
typedef struct search_r search_r;
gboolean search_match(struct search_q *q,struct search_r *r);
typedef struct adc_cmd adc_cmd;
struct search_r *search_parse_adc(struct hub *hub,struct adc_cmd *cmd);
struct search_r *search_parse_nmdc(struct hub *hub,char *msg);
struct search_r *search_r_copy(struct search_r *r);
void search_r_free(gpointer data);
void search_q_free(struct search_q *q);
typedef struct search_type search_type;
struct search_type {
  char *name;
  char *exts[25];
};
extern struct search_type search_types[];
struct search_r {
  guint64 uid;
  char *file;     // full path + filename. Slashes as path saparator, no trailing slash
  guint64 size;   // file size, G_MAXUINT64 = directory
  int slots;      // free slots
  char tth[24];   // TTH root (for regular files)
};
struct search_q {
  char type;    // NMDC search type (if 9, ignore all fields except tth)
  gboolean ge;  // TRUE -> match >= size; FALSE -> match <= size
  guint64 size; // 0 = disabled.
  char **query; // list of patterns to include
  char tth[24]; // only used when type = 9
};
void adc_append(GString *c,const char *name,const char *arg);
GString *adc_generate(char type,int cmd,int source,int dest);
char **adc_getparams(char **a,char *name);
char *adc_getparam(char **a,char *name,char ***left);
void adc_parse(const char *str,struct adc_cmd *c,int *feats,GError **err);
#define ADC_S_DATA     4
#define ADC_S_NORMAL   3
#define ADC_S_VERIFY   2
#define ADC_S_IDENTIFY 1
#define ADC_S_PROTOCOL 0
struct adc_cmd {
  char type;  // B|C|D|E|F|H|I|U
  int cmd;    // ADCC_*, but can also be something else. Unhandled commands should be ignored anyway.
  int source; // Only when type = B|D|E|F
  int dest;   // Only when type = D|E
  char **argv;
  char argc;
};
#define ADC_TOCMDV(a, b, c) ((a) + ((b)<<8) + ((c)<<16))
enum adc_commands {
#define C(n, a, b, c) ADCC_##n = ADC_TOCMDV(a,b,c)
  // Base commands (copied from DC++ / AdcCommand.h)
  C(SUP, 'S','U','P'), // F,T,C    - PROTOCOL, NORMAL
  C(STA, 'S','T','A'), // F,T,C,U  - All
  C(INF, 'I','N','F'), // F,T,C    - IDENTIFY, NORMAL
  C(MSG, 'M','S','G'), // F,T      - NORMAL
  C(SCH, 'S','C','H'), // F,T,C    - NORMAL (can be in U, but is discouraged)
  C(RES, 'R','E','S'), // F,T,C,U  - NORMAL
  C(CTM, 'C','T','M'), // F,T      - NORMAL
  C(RCM, 'R','C','M'), // F,T      - NORMAL
  C(GPA, 'G','P','A'), // F        - VERIFY
  C(PAS, 'P','A','S'), // T        - VERIFY
  C(QUI, 'Q','U','I'), // F        - IDENTIFY, VERIFY, NORMAL
  C(GET, 'G','E','T'), // C        - NORMAL (extensions may use in it F/T as well)
  C(GFI, 'G','F','I'), // C        - NORMAL
  C(SND, 'S','N','D'), // C        - NORMAL (extensions may use it in F/T as well)
  C(SID, 'S','I','D')  // F        - PROTOCOL
#undef C
};
typedef enum adc_commands adc_commands;
#define ADC_TOCMD(str) ADC_TOCMDV((str)[0], (str)[1], (str)[2])
#define ADC_DFCC(str) ((str)[0] + ((str)[1]<<8) + ((str)[2]<<16) + ((str)[3]<<24))
#define ADC_EFCC(sid, str) do {\
    (str)[0] = ((sid)>> 0) & 0xFF;\
    (str)[1] = ((sid)>> 8) & 0xFF;\
    (str)[2] = ((sid)>>16) & 0xFF;\
    (str)[3] = ((sid)>>24) & 0xFF;\
  } while(0)
char *adc_escape(const char *str,gboolean nmdc);
char *adc_unescape(const char *str,gboolean nmdc);
char *nmdc_lock2key(char *lock);
char *nmdc_unescape_and_decode(struct hub *hub,const char *str);
char *nmdc_encode_and_escape(struct hub *hub,const char *str);
char *charset_convert(struct hub *hub,gboolean to_utf8,const char *str);
typedef struct ratecalc ratecalc;
char *ratecalc_eta(struct ratecalc *rc,guint64 left);
extern GSList *ratecalc_list;
#define ratecalc_calc() do {\
    GSList *n; int cur; struct ratecalc *rc;\
    for(n=ratecalc_list; n; n=n->next) {\
      rc = n->data;\
      do {\
        cur = g_atomic_int_get(&(rc->counter));\
      } while(!g_atomic_int_compare_and_exchange(&(rc->counter), cur, 0));\
      rc->total += cur;\
      rc->rate = cur + ((rc->rate - cur) / 2);\
    }\
  } while(0)
#define ratecalc_get(rc) ((rc)->rate)
#define ratecalc_register(rc) do { if(!(rc)->isreg) {\
    ratecalc_list = g_slist_prepend(ratecalc_list, rc);\
    (rc)->isreg = 1;\
  } } while(0)
#define ratecalc_unregister(rc) do {\
    ratecalc_list = g_slist_remove(ratecalc_list, rc);\
    (rc)->isreg = (rc)->rate = 0;\
  } while(0)
#define ratecalc_reset(rc) do {\
    g_atomic_int_set(&((rc)->counter), 0);\
    (rc)->rate = (rc)->total = 0;\
  } while(0)
#define ratecalc_init(rc) do {\
    ratecalc_unregister(rc);\
    ratecalc_reset(rc);\
  } while(0)
#define ratecalc_add(rc, b) g_atomic_int_add(&((rc)->counter), b)
struct ratecalc {
  int counter;
  int rate;
  guint64 total;
  char isreg;
};
char *ip4_unpack(guint32 ip);
guint32 ip4_pack(const char *str);
#define istth(s) (strlen(s) == 39 && strspn(s, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ234567") == 39)
char **file_tail(const char *fn,int n);
void path_suggest(char *opath,char **sug);
int cmpstringp(const void *p1,const void *p2);
char *path_expand(const char *path);
gboolean tiger_hash_equal(gconstpointer a,gconstpointer b);
void str_arg2_split(char *str,char **first,char **second);
void strv_prefix(char **arr,const char *str,...);
guint64 str_parsesize(const char *str);
char *str_casestr(const char *haystack,const char *needle);
char *str_fullsize(guint64 size);
char *str_formatsize(guint64 size);
int str_offset_from_columns(const char *str,int col);
int str_columns(const char *str);
gboolean str_convert_check(const char *fmt,GError **err);
char *str_convert(const char *to,const char *from,const char *str);
void conf_group_rename(const char *from,const char *to);
void base32_decode(const char *from,char *to);
void conf_save();
void conf_init();
void base32_encode(const char *from,char *to);
guint64 rand_64();
extern GKeyFile *conf_file;
#define conf_log_debug() (\
  !conf_file ? TRUE : !g_key_file_has_key(conf_file, "log", "log_debug", NULL) ? FALSE :\
    g_key_file_get_boolean(conf_file, "log", "log_debug", NULL))
#define conf_download_slots() (\
  !g_key_file_has_key(conf_file, "global", "download_slots", NULL) ? 3\
    : g_key_file_get_integer(conf_file, "global", "download_slots", NULL))
extern const char *conf_dir;
#define conf_download_dir() (\
  !g_key_file_has_key(conf_file, "global", "download_dir", NULL) ? g_build_filename(conf_dir, "dl", NULL)\
    : g_key_file_get_string(conf_file, "global", "download_dir", NULL))
#define conf_minislot_size() (1024*(\
  !g_key_file_has_key(conf_file, "global", "minislot_size", NULL) ? 64\
    : g_key_file_get_integer(conf_file, "global", "minislot_size", NULL)))
#define conf_minislots() (\
  !g_key_file_has_key(conf_file, "global", "minislots", NULL) ? 3\
    : g_key_file_get_integer(conf_file, "global", "minislots", NULL))
#define conf_slots() (\
  !g_key_file_has_key(conf_file, "global", "slots", NULL) ? 10\
    : g_key_file_get_integer(conf_file, "global", "slots", NULL))
#define conf_autorefresh() (\
  !g_key_file_has_key(conf_file, "global", "autorefresh", NULL) ? 60\
    : g_key_file_get_integer(conf_file, "global", "autorefresh", NULL))
#define conf_encoding(hub) (\
  g_key_file_has_key(conf_file, hub, "encoding", NULL)\
    ? g_key_file_get_string(conf_file, hub, "encoding", NULL) \
    : g_key_file_has_key(conf_file, "global", "encoding", NULL) \
    ? g_key_file_get_string(conf_file, "global", "encoding", NULL) \
    : g_strdup("UTF-8"))
#define conf_hub_get(type, name, key) (\
  g_key_file_has_key(conf_file, name, (key), NULL)\
    ? g_key_file_get_##type(conf_file, name, (key), NULL)\
    : g_key_file_get_##type(conf_file, "global", (key), NULL))
extern char conf_pid[24];
extern char conf_cid[24];
#define gunichar_width(x) (g_unichar_iswide(x) ? 2 : g_unichar_iszerowidth(x) ? 0 : 1)
#define loglevel_to_str(level) (\
  (level) & G_LOG_LEVEL_ERROR    ? "ERROR"    :\
  (level) & G_LOG_LEVEL_CRITICAL ? "CRITICAL" :\
  (level) & G_LOG_LEVEL_WARNING  ? "WARNING"  :\
  (level) & G_LOG_LEVEL_MESSAGE  ? "message"  :\
  (level) & G_LOG_LEVEL_INFO     ? "info"     : "debug")
#define INTERFACE 0
